--
-- Breakdown 
-- Specialization for combine - Allows a combine to breakdown ( engine failure ) and be repaired.
--
-- @author  Bayn - www.tsforum3.com
-- @date  14/07/09
--

Breakdown = {};

function Breakdown.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Combine, specializations);
end;

function Breakdown:load(xmlFile)
	
	
	------------------------------------------
	------ Keys ------------
	------------------------------------------


	self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	

	
   -- Panel movements --
	
	local rotationNodePanel1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPanel1#index"));
    if rotationNodePanel1 ~= nil then
        self.rotationPanel1 = {};
        self.rotationPanel1.node = rotationNodePanel1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel1#minRot"));
        self.rotationPanel1.minRot = {};
        self.rotationPanel1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel1#maxRot"));
        self.rotationPanel1.maxRot = {};
        self.rotationPanel1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPanel1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel1#rotTime"), 2)*1000;
        self.rotationPanel1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel1#touchRotLimit"), 10));
    end; 	
  
	local rotationNodePanel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPanel2#index"));
    if rotationNodePanel2 ~= nil then
        self.rotationPanel2 = {};
        self.rotationPanel2.node = rotationNodePanel2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel2#minRot"));
        self.rotationPanel2.minRot = {};
        self.rotationPanel2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel2#maxRot"));
        self.rotationPanel2.maxRot = {};
        self.rotationPanel2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPanel2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel2#rotTime"), 2)*1000;
        self.rotationPanel2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel2#touchRotLimit"), 10));
    end; 

	local rotationNodePanel3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPanel3#index"));
    if rotationNodePanel3 ~= nil then
        self.rotationPanel3 = {};
        self.rotationPanel3.node = rotationNodePanel3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel3#minRot"));
        self.rotationPanel3.minRot = {};
        self.rotationPanel3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPanel3#maxRot"));
        self.rotationPanel3.maxRot = {};
        self.rotationPanel3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPanel3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPanel3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPanel3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel3#rotTime"), 2)*1000;
        self.rotationPanel3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPanel3#touchRotLimit"), 10));
    end; 	
	
	local rotationNodeEchellePanel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationEchellePanel#index"));
    if rotationNodeEchellePanel ~= nil then
        self.rotationEchellePanel = {};
        self.rotationEchellePanel.node = rotationNodeEchellePanel;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationEchellePanel#minRot"));
        self.rotationEchellePanel.minRot = {};
        self.rotationEchellePanel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationEchellePanel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationEchellePanel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationEchellePanel#maxRot"));
        self.rotationEchellePanel.maxRot = {};
        self.rotationEchellePanel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationEchellePanel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationEchellePanel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationEchellePanel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationEchellePanel#rotTime"), 2)*1000;
        self.rotationEchellePanel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationEchellePanel#touchRotLimit"), 10));
    end; 
	
	-- Sounds --
	
    BreakdownSoundFile = Utils.getFilename("Breakdown.ogg", self.baseDirectory);
    self.BreakdownSoundId = createSample("BreakdownSound");
    loadSample(self.BreakdownSoundId, BreakdownSoundFile, false);
    self.BreakdownPlaying = false;
	
	
	-- Generating a random number --
	self.RandomNumber = math.random(2,15);	
	--print ("nombre:" , self.RandomNumber);

	self.AuthorizeBreakdown = true;
	self.BreakdownLights = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.BreakdownLights#index"));
    
end;

function Breakdown:delete()

    if self.BreakdownSound ~= nil then
        delete(self.BreakdownSound);
    end;
	
end;

function Breakdown:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Breakdown:keyEvent(unicode, sym, modifier, isDown)


		if isDown and sym == self.keys.Panneaux then
			self.Panels = not self.Panels;
		end
end;

function Breakdown:update(dt)
    	
		-- Movements --
	
	local doRotate = self.rotationPanel1Max or self.rotationPanel1Min 
	if self.rotationPanel1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPanel1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPanel1.maxRot, self.rotationPanel1.minRot, 3, self.rotationPanel1.rotTime, dt, not self.rotationPanel1Max);
        setRotation(self.rotationPanel1.node, unpack(newRot));
    end;	
	
	local doRotate = self.rotationPanel2Max or self.rotationPanel2Min 
	if self.rotationPanel2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPanel2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPanel2.maxRot, self.rotationPanel2.minRot, 3, self.rotationPanel2.rotTime, dt, not self.rotationPanel2Max);
        setRotation(self.rotationPanel2.node, unpack(newRot));
    end;	
	
	local doRotate = self.rotationPanel3Max or self.rotationPanel3Min 
	if self.rotationPanel3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPanel3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPanel3.maxRot, self.rotationPanel3.minRot, 3, self.rotationPanel3.rotTime, dt, not self.rotationPanel3Max);
        setRotation(self.rotationPanel3.node, unpack(newRot));
    end;

	local doRotate = self.rotationEchellePanelMax or self.rotationEchellePanelMin 
	if self.rotationEchellePanel ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationEchellePanel.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationEchellePanel.maxRot, self.rotationEchellePanel.minRot, 3, self.rotationEchellePanel.rotTime, dt, not self.rotationEchellePanelMax);
        setRotation(self.rotationEchellePanel.node, unpack(newRot));
    end;
	-- Panels Movements --
	
	if self.Panels then
		self.rotationPanel1Max = true;
		self.rotationPanel2Max = true;
		self.rotationPanel3Max = true;	
		self.rotationEchellePanelMax = true;	
		self.rotationPanel1Min = false;
		self.rotationPanel2Min = false;
		self.rotationPanel3Min = false;
		self.rotationEchellePanelMin = false;
		self.AuthorizeBreakdown = false;

	else
		self.rotationPanel1Max = false;
		self.rotationPanel2Max = false;
		self.rotationPanel3Max = false;
		self.rotationEchellePanelMax = false;
		self.rotationPanel1Min = true;
		self.rotationPanel2Min = true;
		self.rotationPanel3Min = true;
		self.rotationEchellePanelMin = true;
	end;
		

	
	-- Breakdown OFF : open the panel if HectarTreshed == random number -- 
	
	
	if g_currentMission.missionStats.hectaresThreshedSession >= self.RandomNumber then
		self.Breakdown = true;
	end;
	
	if self.AuthorizeBreakdown and self.Breakdown then
		
		-- stopTreshing --
			self.isThreshingStarted = false;
			self.playThreshingSound = false;
			
			if self.isHired then
				WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeed, 0, false, 0);
				renderText(0.732, 0.38, 0.0250, string.format("Should stop combine"));
			end;
			

			if self.threshingSound ~= nil then
				stopSample(self.threshingSound);
			end;

			if self.threshingStopSound ~= nil and self.threshingSoundActive and self:getIsActiveForSound() then
				setSamplePitch(self.threshingStopSound, self.threshingStopSoundPitchOffset);
				playSample(self.threshingStopSound, 1, 1, 0);
				self.threshingSoundActive = false;
			end;

			self.chopperActivated = false;
			self.isThreshing = false;
			for cutter,implement in pairs(self.attachedCutters) do
				local jointDesc = self.attacherJoints[implement.jointDescIndex];
				jointDesc.moveDown = false;

				cutter:onStopReel();
			end;
			
			if self.currentStrawParticleSystem ~= nil then
                Utils.setEmittingState(self.currentStrawParticleSystem, false);
            end;
		-- Display warning lights --
			setVisibility(self.BreakdownLights, true);
		-- Play Sound --
		if self:getIsActiveForSound() then
			if not self.BreakdownPlaying then
				playSample(self.BreakdownSoundId, 1, 1, 0);
				self.BreakdownPlaying = true;
			end;
        end;
	else
			setVisibility(self.BreakdownLights, false);
			if self.BreakdownPlaying then
				stopSample(self.BreakdownSoundId);
				self.BreakdownPlaying = false;
			end;
	end;

	
end;

function Breakdown:onLeave()
end;

function Breakdown:onEnter()
end;

function Breakdown:draw()
end;
